<?php
/* --------------------------------------------------------------
  StyleEdit4ThemeInitialisationService.php 2019-12-17
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2019 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------*/

namespace Gambio\StyleEdit\Core\ExternalServices;

use Curl\Curl;
use Gambio\GX\Services\System\ThemeSettings\Interfaces\ThemeInitialisationServiceInterface;

/**
 * Class StyleEdit4ThemeInitialisationService
 */
class StyleEdit4ThemeInitialisationService implements ThemeInitialisationServiceInterface
{
    /**
     * @var Curl
     */
    protected $curl;
    
    
    /**
     * StyleEdit4ThemeInitialisationService constructor.
     *
     * @param Curl $curl
     */
    public function __construct(Curl $curl)
    {
        $this->curl = $curl;
    }
    
    
    /**
     * @inheritDoc
     */
    public function initialiseSettings(string $themeId): void
    {
        // loading the theme configuration in styleEdit
        // creates a settings.json with the default values
        $defaultsUri = $this->baseUri() . 'GXModules/Gambio/StyleEdit/Api/api.php/styleedit/de/Default/' . $themeId;
        $this->curl->get($defaultsUri);
    }
    
    /**
     * @return string
     */
    protected function baseUri(): string
    {
        if (defined('ENABLE_SSL')) {
            
            return (ENABLE_SSL ? HTTPS_SERVER : HTTP_SERVER) . DIR_WS_CATALOG;
        }
        
        return (ENABLE_SSL_CATALOG === 'true' ? HTTPS_CATALOG_SERVER : HTTP_CATALOG_SERVER) . DIR_WS_CATALOG;
    }
}