<?php
/* --------------------------------------------------------------
   dependent.inc.php 2020-01-06
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2019 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/
/** @var DatabaseModel $this */

/**
 * Update footer copyright year
 */
$row = $this->query("SELECT `gm_value` FROM `gm_configuration` WHERE `gm_key` = 'GM_FOOTER'");
if(!empty($row))
{
    $oldValue = $row[0]['gm_value'];
    $newValue = preg_replace('/20[\d]{2}/', '2020', $oldValue);
    $t_query  = "UPDATE `gm_configuration`
SET `gm_value` = '" . $this->coo_mysqli->real_escape_string($newValue) . "'
WHERE `gm_key` = 'GM_FOOTER'";
    $t_success &= is_numeric($this->query($t_query));
}

$check = $this->query("SELECT `gm_value`, `languages_id` FROM `gm_contents` WHERE `gm_key` = 'GM_FOOTER'");
foreach($check as $row)
{
    $oldValue = $row['gm_value'];
    $newValue = preg_replace('/20[\d]{2}/', '2020', $oldValue);
    $t_query  = "UPDATE `gm_contents`
SET `gm_value` = '" . $this->coo_mysqli->real_escape_string($newValue) . "'
WHERE `gm_key` = 'GM_FOOTER' AND `languages_id` = " . $row['languages_id'];
    $t_success &= is_numeric($this->query($t_query));
}

$cookieConsentPanelPurposesTableExistsQuery = 'SHOW TABLES LIKE \'cookie_consent_panel_purposes\';';
$row = $this->query($cookieConsentPanelPurposesTableExistsQuery, true);

if ($row->num_rows < 1) {
 
    $query = 'CREATE TABLE `cookie_consent_panel_purposes` (
        `purpose_id` int(8) NOT NULL AUTO_INCREMENT,
        `language_id` int(8) NOT NULL,
        `category_id` int(8) NOT NULL,
        `purpose_description` varchar(255) NOT NULL,
        `purpose_name` varchar(128) NOT NULL,
        `purpose_alias` varchar(128),
        `purpose_status` boolean DEFAULT true NOT NULL,
        `purpose_deletable` boolean DEFAULT true NOT NULL,
        PRIMARY KEY (`purpose_id`, `language_id`)
    ) ENGINE=InnoDB  DEFAULT CHARSET=utf8;';
    
    $this->query($query);
    
    $query = 'INSERT INTO `cookie_consent_panel_purposes` (`purpose_id`, `language_id`, `category_id`, `purpose_description`, `purpose_name`, `purpose_alias`, `purpose_status`, `purpose_deletable`)
              VALUES
              -- Session Cookies
              (1, 1, 1, \'\', \'Session Cookies\', null, 1, 0),
              (1, 2, 1, \'\', \'Session Cookies\', null, 1, 0),
              -- Setting Cookies
              (2, 1, 1, \'\', \'Setting Cookies\', null, 1, 0),
              (2, 2, 1, \'\', \'Cookie-Einstellungen\', null, 1, 0),
              -- Google Analytics
              (4, 1, 3, \'\', \'Google Analytics\', null, 0, 0),
              (4, 2, 3, \'\', \'Google Analytics\', null, 0, 0);';
    
    $this->query($query);
}