<?php
/* --------------------------------------------------------------
   dependent.inc.php 2020-02-05
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/
/** @var DatabaseModel $this */

//  Adding new Google Recaptcha purpose
$query = 'REPLACE INTO `cookie_consent_panel_purposes` (`purpose_id`, `language_id`, `category_id`, `purpose_description`, `purpose_name`, `purpose_alias`, `purpose_status`, `purpose_deletable`)
          VALUES
                 (3, 1, 2, "", "Google Recaptcha", NULL, 0, 0),
                 (3, 2, 2, "", "Google Recaptcha", NULL, 0, 0);';

$this->query($query);

$query = 'UPDATE `cookie_consent_panel_purposes` SET `purpose_deletable` = 0 WHERE `purpose_id` <= 4;';
$this->query($query);

// Alter table because of Error message: Index column size too large. The maximum column size is 767 bytes
$query = "ALTER TABLE emails MODIFY subject varchar(255) NOT NULL DEFAULT ''";
$this->query($query);

$query = 'ALTER TABLE email_contacts ROW_FORMAT=DYNAMIC;';
$this->query($query);

$query = 'ALTER TABLE emails ROW_FORMAT=DYNAMIC;';
$this->query($query);

//  MYSQL
$tables = [
    'emails'         => [
        'emails_creation_date_index' => 'create index `emails_creation_date_index` on `emails`(`creation_date`)',
        'emails_sent_date_index'     => 'create index `emails_sent_date_index`	on `emails`(`sent_date`)',
        'emails_subject_index'       => 'create index `emails_subject_index`	on `emails`(`subject`)'
    ],
    'email_contacts' => [
        'email_contacts_email_address_index' => 'create index `email_contacts_email_address_index` on `email_contacts`(`email_address`);'
    ]
];

foreach ($tables as $table => $indexes) {
    if (isset($table, $indexes)) {
        foreach ($indexes as $name => $createIndex) {
            if (empty($this->query("SELECT `index_name` FROM `INFORMATION_SCHEMA`.`STATISTICS`
                           WHERE `table_schema` = database()
                           AND   `table_name`   = '$table'
                           AND   `index_name`   = '$name'"))) {
                $this->query($createIndex);
            }
        }
    }
}

// setting the Alias for DP (Deutsche Post) to DP

$query = 'UPDATE `configuration` SET `configuration_value` = "Deutsche Post" WHERE `configuration_key` = "MODULE_SHIPPING_DP_ALIAS"';
$this->query($query);
